﻿
using Syncfusion.XForms.DataForm;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace FormLayout.Model
{
    [Serializable]
    public class Customer :INotifyPropertyChanged, INotifyDataErrorInfo
    {
        public event PropertyChangedEventHandler PropertyChanged;

        event EventHandler<DataErrorsChangedEventArgs> INotifyDataErrorInfo.ErrorsChanged
        {
            add { }
            remove { }
        }

        private void RaisePropertyChanged(String Name)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(Name));
        }


        private string _code = "";

        public string Code
        {
            get => _code;
            set
            {
                _code = value;
                RaisePropertyChanged("Code");
            }
        }

        private string _name = "";

        public string Name
        {
            get => _name;
            set
            {
                _name = value;
                RaisePropertyChanged("Name");
            }
        }


        private string _customerGroup = "";

        public string CustomerGroup
        {
            get => _customerGroup;
            set
            {
                _customerGroup = value;
                RaisePropertyChanged("CustomerGroup");
            }
        }

        private string _address = "";

        public string Address
        {
            get => _address;
            set
            {
                _address = value;
                RaisePropertyChanged("Address");
            }
        }

        private string _bank = "";

        public string Bank
        {
            get => _bank;
            set
            {
                _bank = value;
                RaisePropertyChanged("Bank");
            }
        }

        bool INotifyDataErrorInfo.HasErrors => Address == "";
               
        IEnumerable INotifyDataErrorInfo.GetErrors(string propertyName)
        {
            var list = new List<string>();
            if (!propertyName.Equals("Address"))
                return list;

            if (this.Address == "")
                list.Add("Address should not empty");
            return list;
        }
    }
}
